Index: trunk/configure
===================================================================
--- trunk/configure	(revision 6124)
+++ trunk/configure	(revision 6125)
@@ -52,10 +52,4 @@
 GENISOIMAGE="genisoimage"
 MKISOFS="mkisofs"
-INCXALAN="/usr/local/include"
-LIBXALAN="-lxalan-c"
-LIBXALAN_DIR="/usr/local/lib"
-INCXERCES="/usr/local/include"
-LIBXERCES="-lxerces-c"
-LIBXERCES_DIR="/usr/local/lib"
 BUILD_LIBXML2=
 LIBCRYPTO="-lcrypto"
@@ -538,84 +532,6 @@
 
 #
-# Check for xalan, needed by VBoxXML
-#
-check_xalan()
-{
-  if [ -n "$LIBXALAN" ]; then
-    test_header xalan
-    cat > .tmp_src.cc << EOF
-#include <cstdio>
-#include <xalanc/Include/XalanVersion.hpp>
-extern "C" int main(void)
-{
-  printf("found version %d.%d.%d",
-         XALAN_VERSION_MAJOR, XALAN_VERSION_MINOR, XALAN_VERSION_REVISION);
-#if _XALAN_VERSION >= 10800
-  printf(", OK.\n");
-  return 0;
-#else
-  printf(", expected version 1.8.0 or higher\n");
-  return 1;
-#endif
-}
-EOF
-    [ -n "$INCXALAN" ] && I_INCXALAN=`prefix_I "$INCXALAN"`
-    if test_compile "$LIBXALAN $LIBPTHREAD $I_INCXALAN" xalan xalanc; then
-      if test_execute; then
-        cnf_append "SDK_VBOX_XALAN_LIBS"    "`strip_l "$LIBXALAN"`"
-        cnf_append "SDK_VBOX_XALAN_LIBPATH" "`strip_L "$LIBXALAN"`"
-        cnf_append "SDK_VBOX_XALAN_INCS"    "$INCXALAN"
-      fi
-    fi
-  else
-    echo "Building xalan from shipped sources."
-    echo "Building xalan from shipped sources." >> $LOG
-    echo >> $LOG
-    echo >> $LOG
-  fi
-}
-
-#
-# Check for xerces, needed by VBoxXML
-#
-check_xerces()
-{
-  if [ -n "$LIBXERCES" ]; then
-    test_header xerces
-    cat > .tmp_src.cc << EOF
-#include <cstdio>
-#include <xercesc/util/XercesVersion.hpp>
-extern "C" int main(void)
-{
-  printf("found version %d.%d.%d",
-         XERCES_VERSION_MAJOR, XERCES_VERSION_MINOR, XERCES_VERSION_REVISION);
-#if _XERCES_VERSION >= 20500
-  printf(", OK.\n");
-  return 0;
-#else
-  printf(", expected version 2.5.0 or higher\n");
-  return 1;
-#endif
-}
-EOF
-    [ -n "$INCXERCES" ] && I_INCXERCES=`prefix_I "$INCXERCES"`
-    if test_compile "$LIBXERCES $LIBPTHREAD $I_INCXERCES" xerces xercesc; then
-      if test_execute; then
-        cnf_append "SDK_VBOX_XERCES_LIBS"    "`strip_l "$LIBXERCES"`"
-        cnf_append "SDK_VBOX_XERCES_LIBPATH" "`strip_L "$LIBXERCES"`"
-        cnf_append "SDK_VBOX_XERCES_INCS"    "$INCXERCES"
-      fi
-    fi
-  else
-    echo "Building xerces from shipped sources."
-    echo "Building xerces from shipped sources." >> $LOG
-    echo >> $LOG
-    echo >> $LOG
-  fi
-}
-
-#
-# Check for libxml2, needed by xpcom
-# For now we check for libxml2 2.6.23 as 2.6.22 is known to NOT work
+# Check for libxml2, needed by VBoxSettings
+# 2.6.23 is known to NOT work, 2.6.24 is known to work (e.g. Ubuntu/Dapper)
 #
 check_libxml2()
@@ -1374,5 +1290,4 @@
   --disable-sdl-ttf        disable SDL_ttf detection
   --disable-pulse          disable PulseAudio detection
-  --build-xalan            build xalan & xerces from sources (not OSE!)
   --build-libxml2          build libxml2 from sources (not OSE!)
   --setup-wine             setup a Wine directory and register the hhc hack
@@ -1386,10 +1301,4 @@
   --with-mkisofs=PATH      location of mkisofs [$MKISOFS]
   --with-qt-dir=DIR        directory for QT headers/libraries [$QTDIR]
-  --with-xalan=LIB         location of the xalan library [$LIBXALAN]
-  --with-xalan-incdir=DIR  location of the xalan headers [/usr/include /usr/local/include]
-  --with-xalan-libdir=DIR  location of the xalan library [/usr/lib /usr/local/lib]
-  --with-xerces=LIB        location of the xerces library [$LIBXERCES]
-  --with-xerces-incdir=DIR location of the xerces headers [/usr/include /usr/local/include]
-  --with-xerces-libdir=DIR location of the xerces library [/usr/lib /usr/local/lib]
 
 Build type:
@@ -1439,22 +1348,4 @@
       MKISOFS=`echo $option | cut -d'=' -f2`
       ;;
-    --with-xalan=*)
-      LIBXALAN=`echo $option | cut -d'=' -f2`
-      ;;
-    --with-xalan-libdir=*)
-      LIBXALAN_DIR=`echo $option | cut -d'=' -f2`
-      ;;
-    --with-xalan-incdir=*)
-      INCXALAN=`echo $option | cut -d'=' -f2`
-      ;;
-    --with-xerces=*)
-      LIBXERCES=`echo $option | cut -d'=' -f2`
-      ;;
-    --with-xerces-libdir=*)
-      LIBXERCES_DIR=`echo $option | cut -d'=' -f2`
-      ;;
-    --with-xerces-incdir=*)
-      INCXERCES=`echo $option | cut -d'=' -f2`
-      ;;
     --disable-xpcom)
       WITH_XPCOM=0
@@ -1471,10 +1362,4 @@
     --build-debug|-d)
       BUILD_TYPE=debug
-      ;;
-    --build-xalan)
-      LIBXERCES=
-      LIBXERCES_DIR=
-      LIBXALAN=
-      LIBXALAN_DIR=
       ;;
     --build-libxml2)
@@ -1505,7 +1390,4 @@
   esac
 done
-
-[ -n "$LIBXALAN_DIR" ] && LIBXALAN="-L$LIBXALAN_DIR $LIBXALAN"
-[ -n "$LIBXERCES_DIR" ] && LIBXERCES="-L$LIBXERCES_DIR $LIBXERCES"
 
 LOG="$ODIR$LOG"
@@ -1600,6 +1482,4 @@
 # the libraries
 [ "$OS" != "darwin"  ] && check_pthread
-[ $WITH_XPCOM  -eq 1 ] && check_xalan
-[ $WITH_XPCOM  -eq 1 ] && check_xerces
 [ $WITH_XPCOM  -eq 1 ] && check_libxml2
 [ $WITH_LIBIDL -eq 1 ] && check_libidl
Index: trunk/debian/control
===================================================================
--- trunk/debian/control	(revision 6124)
+++ trunk/debian/control	(revision 6125)
@@ -5,7 +5,6 @@
 Standards-Version: 3.2.1
 Build-Depends: debhelper (>= 5), libz-dev, libssl-dev, libqt3-headers, qt3-dev-tools, libsdl1.2-dev,
-  uuid-dev, libxalan110-dev, libxerces27-dev, libxcursor-dev, libidl-dev, libpam0g-dev,
-  bcc, iasl, xsltproc, linux-headers-generic, wine, java2-runtime, lsb-release, g++-multilib [amd64],
-  libc6-dev-i386 [amd64], ia32-libs [amd64]
+  uuid-dev, libxcursor-dev, libidl-dev, libpam0g-dev, bcc, iasl, xsltproc, linux-headers-generic, wine,
+  java2-runtime, lsb-release, g++-multilib [amd64], libc6-dev-i386 [amd64], ia32-libs [amd64]
 
 Package: virtualbox-ose
Index: trunk/debian/rules
===================================================================
--- trunk/debian/rules	(revision 6124)
+++ trunk/debian/rules	(revision 6125)
@@ -60,5 +60,4 @@
 	    $(ose),--ose,) $(if $(LINUX),--with-linux=$(LINUX),) $(if \
 	    $(filter _Ubuntu_dapper,$(debrel)),--with-gcc=gcc-3.4 --with-g++=g++-3.4,) $(if \
-	    $(filter _xandros4.1,$(debrel)),--build-xalan,) $(if \
 	    $(filter _xandros4.1 _ucs1.3,$(debrel)),--disable-sdl-ttf,) $(if \
 	    $(HEADLESS),--build-headless,) $(if $(DEBUG),--build-debug,)